# Class FTPStream

java.lang.Object
java.io.InputStream
java.io.FilterInputStream
htsjdk.samtools.util.ftp.FTPStream

All Implemented Interfaces:
  `Closeable, AutoCloseable`

public class FTPStream extends FilterInputStream
A "non-seekable" ftp stream. This one doesn't support random access. It is assumed that the ftp client has been connected, put in passive mode, set to binary, and otherwise prepped for reading before creating this stream.

## Field Summary

### Fields inherited from class FilterInputStream

`in`

## Constructor Summary

Constructors
Constructor
Description
`FTPStream(FTPClient ftp)`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
`int`
`read(byte[] bytes, int i, int i1)`

### Methods inherited from class FilterInputStream

`available, mark, markSupported, read, read, reset, skip`

### Methods inherited from class InputStream

`nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### FTPStream

public FTPStream(FTPClient ftp) throws IOException

Throws:
  `IOException`

## Method Details

### read

public int read(byte[] bytes, int i, int i1) throws IOException

Overrides:
  `read` in class `FilterInputStream`
Throws:
  `IOException`

### close

public void close() throws IOException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Overrides:
  `close` in class `FilterInputStream`
Throws:
  `IOException`